﻿using UnityEngine;
using System.Collections;

public class InputController : MonoBehaviour {

	private PlayerMovementController moveCtrl;
	private Camera mainCamera;

	void Start () {
		moveCtrl = gameObject.GetComponent<PlayerMovementController>();
		GameObject camGO = GameObject.Find ("Main Camera");
		if(camGO == null)
			Debug.LogError("Input Contoller could not find 'Main Camera' game object.  Required for getting mouse input.  Fix it.");
		mainCamera = camGO.GetComponent<Camera>();
	}

	void Update () {
		Vector2 mousePos = (Vector2)mainCamera.ScreenToWorldPoint(Input.mousePosition);

		moveCtrl.AimPoint = mousePos;

		//moveCtrl.MoveInput = new Vector2(Input.GetAxis("Horizontal"), Input.GetAxis("Vertical"));
		float x =0, y =0;
		if(Input.GetKey(KeyCode.W) || Input.GetKey(KeyCode.UpArrow))
		{
			y = 1;
		}
		else if(Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.DownArrow))
		{
			y = -1;
		}

		if(Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.RightArrow))
		{
			x = 1;
		}
		else if(Input.GetKey(KeyCode.A) || Input.GetKey(KeyCode.LeftArrow))
		{
			x = -1;
		}

		moveCtrl.MoveInput = new Vector2(x,y);

		if(Input.GetMouseButtonDown(0))
			moveCtrl.PullTrigger();
		else if(Input.GetMouseButtonDown(1))
			moveCtrl.PullSecondaryTrigger();


	}
}
