﻿using UnityEngine;
using System.Collections;

[RequireComponent (typeof (Rigidbody2D))]
[RequireComponent (typeof (PlayerStatus))]
public class PlayerMovementController : MonoBehaviour {

	//public float WalkSpeed=5f;
	private PlayerStatus pstat;
	private GunSubController gunsub;
	private Transform gun;

	public Vector2 MoveInput { get; set; }
	private Vector2 aimPoint;
	public Vector2 AimPoint { get { return aimPoint;  } set { gunsub.AimPoint = value; aimPoint = value; } }

	void Start () {
		pstat = gameObject.GetComponent<PlayerStatus>();
		gunsub = gameObject.GetComponent<GunSubController>();
		gun = transform.Find("Gun");
	}
	
	void FixedUpdate () {
		Walk();
		//FaceGunToAim();
	}

	public void PullTrigger()
	{
		gunsub.PullTrigger();
	}

	public void PullSecondaryTrigger()
	{
		gunsub.PullSecondaryTrigger();
	}

	private void Walk()
	{
		Vector2 targetspeed = pstat.WalkingSpeed * MoveInput.normalized;
		Vector2 deltaspeed = targetspeed - GetComponent<Rigidbody2D>().velocity;
		Vector2 force = GetComponent<Rigidbody2D>().mass * deltaspeed / Time.fixedDeltaTime;
		GetComponent<Rigidbody2D>().AddForce(force);
	}

	private void FaceGunToAim()
	{
		if(gun == null)
			return;

		float dx = AimPoint.x - gun.position.x;
		float dy = AimPoint.y - gun.position.y;
		float aimangle = Mathf.RoundToInt(Mathf.Atan2(dx, dy) * -180/Mathf.PI);
		
		gun.eulerAngles = new Vector3(0,0,aimangle);
	}
}
