﻿using UnityEngine;
using System.Collections;

public class PlayerStatus : MonoBehaviour {

	public int InitialMaxHealth;
	public int InitialWalkingSpeed;

	[HideInInspector]
	public int Health;
	[HideInInspector]
	public int MaxHealth;
	
	[HideInInspector]
	public float WalkingSpeed;
	
	private float stunnedUntil=0;
	private float invulUntil=0;
	private GameController gc;
	
	// Use this for initialization
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();
		ResetForNewGame();
	}
	
	void Awake() {
		DontDestroyOnLoad(transform.gameObject);
	}
	
	// Update is called once per frame
	void Update () {
		
	}
	
	public void ResetForNewGame()
	{
		Health = MaxHealth = InitialMaxHealth;
		WalkingSpeed = InitialWalkingSpeed;
	}
	
	public void TakeDamage(int dmg)
	{	
		if(Time.time<=invulUntil)
		{
			return;
		}
		
		iTween.Stab (gameObject, gc.PlayerHitClip, 0);
		invulUntil = Time.time + 0.45f;
		Health -= dmg;
		// causes bug where screen gets permanently faded when events stack quickly:  iTween.CameraFadeFrom(1, 0.04f);
	}
	
	public void ResetForNewLevel()
	{
	}
	
	public bool isInvulnerable()
	{
		return (invulUntil >= Time.time);
	}
	
	public bool IsStunned()
	{
		return (stunnedUntil > Time.time);
	}
	
	public void StunForSeconds(float t)
	{
		stunnedUntil = Time.time + t;
	}

}
