﻿using UnityEngine;
using System.Collections;

public class ProjectileCollision : MonoBehaviour {

	public int DamageDealt=1;
	public float StunTime=0.1f;
	public float Knockback=0.5f;

	public Transform ExplosionPrefab;
	// TODO add code hook to projectile collision
	
	private GameController gc;	
	private GameObject cameraGO;

	// Use this for initialization
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();
		cameraGO = GameObject.Find ("Main Camera");
	}
	
	void OnCollisionEnter2D(Collision2D coll) {
		if (coll.gameObject.tag == "Player")
		{
			PlayerStatus ps = coll.gameObject.GetComponent<PlayerStatus>();
			ps.TakeDamage(DamageDealt);
		}

		if (coll.gameObject.tag == "Monster")
		{
			MonsterStatus ms = coll.gameObject.GetComponent<MonsterStatus>();
			ms.TakeDamage(DamageDealt);
			Vector2 stunvec = (Vector2)(coll.transform.position - transform.position).normalized * 0.5f + (GetComponent<Rigidbody2D>().velocity.normalized * 0.5f);
			ms.Stun(StunTime, stunvec * Knockback);
		}

		if(ExplosionPrefab != null)
		{
			Transform exp = (Transform) GameObject.Instantiate(ExplosionPrefab);
			exp.position = transform.position;
		}

		if(cameraGO != null)
			iTween.ShakePosition(cameraGO, new Vector3(0.1f, 0.1f, 0), 0.05f);

		GameObject.Destroy (gameObject);
	}
}
