﻿using UnityEngine;
using System.Collections;
using System;

[Serializable]
public class AutoExecuter : MonoBehaviour {

	/// <summary>
	/// AI in StatusControlRouter, or direct Controller
	/// </summary>
	public AbstractControlExecutor Executor;
	public Transform GunTransform;
	public GunSubController forcedGunSub=null;
	
	private BasicMoveController move;
	private GunSubController gunsub;
	
	MonsterStatus mstat;
	
	void Start () {
		mstat = gameObject.GetComponent<MonsterStatus>();
		move = (BasicMoveController)gameObject.GetComponent<BasicMoveController>();
		
		if(GunTransform != null)
		{
			if(forcedGunSub==null)
				gunsub = (GunSubController) GunTransform.parent.gameObject.GetComponent<GunSubController>();
			else
				gunsub = forcedGunSub;  // FOR THE BOSS!
		}
	}
	
	void FixedUpdate () {
		if(mstat!=null)
			move.WalkSpeed = mstat.WalkingSpeed;
		
		// relies on AI to set the instructions
		Executor.ExecuteControls(move, new Vector2(0,0), gunsub, GunTransform, new Vector2(0,0), false, false);
	}
}
