﻿using UnityEngine;
using System.Collections;

public class ConfusedExecutor : AbstractControlExecutor {
	private static  float MoveInterval=0.4f;
	private static  float AimInterval=0.3f;
	
	private float nextMoveSwitch;
	private Vector2 moveDir;
	private float nextAimSwitch;
	private Vector2 aimPoint;	

	private GameController gc;
	// Use this for initialization
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();
		
	}
	
	public override bool ExecuteControls(BasicMoveController mctrl, Vector2 movePoint, GunSubController gsub, Transform GunTransform, Vector2 aimPoint, bool trig, bool secondaryTrig)
	{
		//Debug.Log(gameObject.name + "Confused ExecuteControls");
	
		if(nextMoveSwitch <= Time.fixedTime)
			ChangeMove();
			
		if(nextAimSwitch <= Time.fixedTime)
			ChangeAim();
		
		
		PlayerStatus ps  = GetComponent<PlayerStatus>();
		MonsterStatus ms = GetComponent<MonsterStatus>();
		
		if(ps != null)		
			mctrl.WalkSpeed = 0.6f*ps.WalkingSpeed;
		else if(ms != null)		
			mctrl.WalkSpeed = 0.6f*ms.WalkingSpeed;
		
		mctrl.TargetPoint = (Vector2)transform.position + moveDir.normalized*10f;
		gsub.AimPoint = (Vector2)transform.position + aimPoint.normalized*4f;
		
		if(trig)
		{
			gsub.PullTrigger();
		}
		
		if(secondaryTrig)
		{
			gsub.PullSecondaryTrigger();
		}
				
		return true;
	}
	
	private void ChangeMove()
	{
		//Debug.LogError(gameObject.name + "Confused ChangeMove");
		
		nextMoveSwitch = Time.fixedTime + MoveInterval;
		moveDir = new Vector2((float)gc.rand.NextDouble()*2-1, (float)gc.rand.NextDouble()*2-1);
	}

	private void ChangeAim()
	{
		//Debug.LogError(gameObject.name + "Confused ChangeAim");
		
		nextAimSwitch = Time.fixedTime + MoveInterval;
		aimPoint = new Vector2((float)gc.rand.NextDouble()*2-1, (float)gc.rand.NextDouble()*2-1);
	}
	
}
