﻿using UnityEngine;
using System.Collections;

public class InputExecutor : MonoBehaviour {

	public AbstractControlExecutor Executor;

	private Transform gunTransform;
	private BasicMoveController move;
	private GunSubController gunsub;
	
	private Vector2 ctrAim;
	private Vector2 ctrMove;
	private bool ctrTrigger;
	private bool ctrSecTrigger;
	
	private PlayerStatus pstat;
	private Camera mainCamera;
	
	void Start () {
		pstat = gameObject.GetComponent<PlayerStatus>();
		move = (BasicMoveController)gameObject.GetComponent<BasicMoveController>();		
		gunsub = gameObject.GetComponent<GunSubController>();
		gunTransform = transform.Find("Gun");
		
		GameObject camGO = GameObject.Find ("Main Camera");
		if(camGO == null)
			Debug.LogError("Input Contoller could not find 'Main Camera' game object.  Required for getting mouse input.  Fix it.");
		mainCamera = camGO.GetComponent<Camera>();
		
	}
	
	void Update()
	{
		ProcessInput();
	}
	
	private void ProcessInput()
	{
//		Debug.Log("     "+gameObject.name + "InputExecutor.ProcessInput ");
		
	 	Vector2 mousePos = (Vector2)mainCamera.ScreenToWorldPoint(Input.mousePosition);
		
		ctrAim = mousePos;
		
		float x =0, y =0;
		if(Input.GetKey(KeyCode.W) || Input.GetKey(KeyCode.UpArrow))
		{
			y = 1;
		}
		else if(Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.DownArrow))
		{
			y = -1;
		}
		
		if(Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.RightArrow))
		{
			x = 1;
		}
		else if(Input.GetKey(KeyCode.A) || Input.GetKey(KeyCode.LeftArrow))
		{
			x = -1;
		}
		
		ctrMove = new Vector2(x,y);
		
		if(Input.GetMouseButtonDown(0))
			ctrTrigger = true;
		if(Input.GetMouseButtonDown(1))
			ctrSecTrigger = true;
		
	}
	
	void FixedUpdate () {
		move.WalkSpeed = pstat.WalkingSpeed;
		Executor.ExecuteControls(move, ctrMove, gunsub, gunTransform, ctrAim, ctrTrigger, ctrSecTrigger);
		ctrTrigger = ctrSecTrigger = false;
	}
}
