﻿using UnityEngine;
using System.Collections;

public class AnimateFlapping : MonoBehaviour {

	private Animator anim;
	private PlayerStatus pstat;

	private bool diving;
	private bool hovering;
	private bool climbing;
	
	// Use this for initialization
	void Start () {
		anim = transform.GetComponent<Animator>();
		pstat = transform.parent.GetComponent<PlayerStatus>();
	}
	
	void FixedUpdate () {
		
		if(pstat.Health <= 0 )
		{
			diving = true;
			hovering = false;
			climbing = false;
		}
		else
		{
			float a = transform.parent.localEulerAngles.z;
			float s = Mathf.Sin (Mathf.Deg2Rad*a);
			
			diving = (diving) ? s < -0.3f : s < -0.45f;  // made diving "sticky" to avoid twitch-switching at cusp
			hovering = !diving && s < -0.125f;		
			climbing = s > 0.45f;
		}
		
		anim.SetBool("diving", diving);
		anim.SetBool("hovering", hovering);
		anim.SetBool("climbing", climbing);
		
	}
}
