﻿using UnityEngine;
using System.Collections;

public class Archer : MonoBehaviour {

	public Transform ArrowPrefab;
	public Transform LaunchPoint;
	public float LaunchForce;
	public float Range = 15;
	public float AnimationLeadTime = 0.275f;
	public float FireDelay = 0.8f;

	private bool shooting=false;
	private float shotstart;
	private float shotangle;
	private Transform shotarrow;
	
	private float holduntil=0;
	
	private Animator anim;
	private bool animTrigged=false;
	private GameController gc;
	
	// Use this for initialization
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();
		
		anim = transform.GetComponent<Animator>();
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		float dist = Mathf.Abs (gc.Player.position.x - transform.position.x);
		if(!animTrigged && dist > Range)
			return;
	
		if(Time.time > holduntil)
		{
			CreateArrow();
			LaunchArrow();
			animTrigged = false;
		}
		else if(Time.time + AnimationLeadTime > holduntil && !animTrigged)
		{
			// fire anim early for wind-up!
			anim.SetTrigger("shoot");
			animTrigged = true;
		}	
	}
	
	private void CreateArrow()
	{
		shotarrow = (Transform) GameObject.Instantiate(ArrowPrefab);
		
		shotarrow.position = LaunchPoint.position;
		shotarrow.parent = transform;
		shotarrow.localEulerAngles = new Vector3(0,0,0);			
	}
	
	private void LaunchArrow()
	{
		shotarrow.parent = null;
		Vector2 force = new Vector2(transform.localScale.x/-Mathf.Abs(transform.localScale.x),1).normalized * LaunchForce;
		shotarrow.GetComponent<Rigidbody2D>().AddForce(force);
		
		holduntil = Time.time + FireDelay;
	}
}
