﻿using UnityEngine;
using System.Collections;

public class FlightInput : MonoBehaviour {	

	private FlightController flyCtrl;
	private Camera mainCamera;
	private PlayerStatus pstat;
	
	void Start () {
		flyCtrl = gameObject.GetComponent<FlightController>();
		GameObject camGO = GameObject.Find ("Main Camera");
		if(camGO == null)
			Debug.LogError("Input Contoller could not find 'Main Camera' game object.  Required for getting mouse input.  Fix it.");
		mainCamera = camGO.GetComponent<Camera>();
		GameObject pgo = GameObject.Find ("Player");
		pstat = pgo.GetComponent<PlayerStatus>();
	}
	
	
	// Update is called once per frame
	void Update () {
		if(pstat.Health<=0)
		{
			flyCtrl.Controls = new Vector2(0,0);
			return;
		}
		
		float x =0, y =0;
		if(Input.GetKey(KeyCode.W) || Input.GetKey(KeyCode.UpArrow))
		{
			y = 1;
		}
		else if(Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.DownArrow))
		{
			y = -1;
		}
		
		if(Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.RightArrow))
		{
			x = 1;
		}
		else if(Input.GetKey(KeyCode.A) || Input.GetKey(KeyCode.LeftArrow))
		{
			x = -1;
		}
		
		flyCtrl.Controls = new Vector2(x,y);
	}
}
