﻿using UnityEngine;
using System.Collections;

public class KingMover : MonoBehaviour {

	public float MoveSpeed = 2f;
	public float DodgeSpeed = 15f;
	public float DodgeLift = 1f;
	public float DodgeWait = 3f;
	public float WorryRange=2f;
	public float HomeX;

	private GameController gc;
	private Rigidbody2D r2;
	private Vector3 startScale;
	
	private float lastDodgeTime=0;
	private float leap;
	
	public string DEBUG="";
	
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();
		r2 = transform.GetComponent<Rigidbody2D>();
		startScale = transform.localScale;
	}
	
	void FixedUpdate()
	{
		FacePlayer();
		
		float since = Time.time - lastDodgeTime;
		if(since < 1) // some time for dodge to do it's thing, plus take a breath, your majesty
			return;
			
		if(since > DodgeWait && NeedToDodge())
			Dodge();
		else
			WalkCalmly();
	}
	
	private void WalkCalmly()
	{
		float diff = HomeX - transform.position.x;
		if(Mathf.Abs (diff) < 2)
			return;
			
		int direction = 1;
		if(diff<0)
			direction = -1;
			
		Vector2 targetspd = new Vector2(MoveSpeed*direction,0);
		Vector2 delta = targetspd - (Vector2)r2.velocity;
		Vector2 force = r2.mass * delta / Time.fixedDeltaTime;
		force = new Vector2(force.x, 0);
		
		DEBUG = "f "+force.x;
		r2.AddForce(force);
	}	
	
	private bool NeedToDodge()
	{
		leap = DodgeLift;
		float deltax = Mathf.Abs (gc.Player.transform.position.x - transform.position.x);
		if (deltax < WorryRange)
			return true;
		
		leap = 1.3f*DodgeSpeed;
		float deltay = Mathf.Abs (gc.Player.transform.position.y - transform.position.y);
		if (deltay < WorryRange && deltax < 3*WorryRange)
			return true;
		
		return false;
	}	

	private void Dodge()
	{
		lastDodgeTime = Time.time;
		
		int direction = -1;
		if(gc.Player.GetComponent<Rigidbody2D>().velocity.x<0)
			direction = 1;
	
		Vector2 targetspd = new Vector2(DodgeSpeed*direction,leap);
		Vector2 delta = targetspd - (Vector2)r2.velocity;
		Vector2 force = r2.mass * delta / Time.fixedDeltaTime;
		//force = new Vector2(force.x, 0);
		
		r2.AddForce(force);
	}
	
	private void FacePlayer()
	{
		if(gc.Player.transform.position.x < transform.position.x)
			transform.localScale = startScale;
		else
			transform.localScale = new Vector3(-startScale.x, startScale.y, startScale.z);
	}
	
}
