﻿using UnityEngine;
using System.Collections;

public class ProjectileStickIn : MonoBehaviour {	

	public JuiceDropper PlayerHitJuiceDropper;
	public int Damage = 1;

	private GameController gc;
	
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();
		
	}
		
	void OnCollisionEnter2D(Collision2D col)
	{
		SplatTrigger otrig = col.gameObject.GetComponent<SplatTrigger>();
		if(otrig == null && col.gameObject.tag != "PlayerMouth" && col.gameObject.tag != "Weapon")
		{		
			Collider2D mycollider = transform.GetComponent<Collider2D>();
			
			if(mycollider != null)
				mycollider.enabled = false;
					
			if(col.gameObject.layer == LayerMask.NameToLayer("Player")) 
			{
				HitPlayer();
				return;
			}
			
			transform.GetComponent<Rigidbody2D>().isKinematic = true; // stop all physics movements
			RotateFacingMovement rf = transform.GetComponent<RotateFacingMovement>();
			if(rf!=null)
				rf.enabled = false;			
				
			if(col.gameObject.tag != "Ground")
			{								
				transform.parent = col.transform;
			}
			else
				transform.position += new Vector3(0,-0.1f,0);			
			
			//Debug.Log(gameObject.name + " disabling physics and binding to " + col.gameObject.name);
			
		}
	}
	
	private void HitPlayer()
	{		
		GameObject pgo = GameObject.Find ("Player");
		PlayerStatus pstat = pgo.GetComponent<PlayerStatus>();
		if(!pstat.isInvulnerable())
		{
			PlayerHitJuiceDropper.StartDropping();			
			pstat.TakeDamage(Damage);
			Debug.Log(gameObject.name + " hitting player for " + Damage + " leaving " + pstat.Health);			
		}
		else
		{
			Debug.Log(gameObject.name + " skipping hit on INVUL player.");
		}
		GameObject.Destroy(gameObject, 0.2f);
	}
	
}
